//  ꥹ12.7 TimerȤä˥᡼
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class TimerAnimation extends JPanel implements ActionListener {
    int number = -1;
    int cell = 20;
    int interval;
    Image[] image;
    MediaTracker tracker;
    Timer timer;

    TimerAnimation() {
        //᡼Υ
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        tracker = new MediaTracker(this);
        image = new Image[cell];
        for (int i = 1; i <= cell; i++) {
           image[i-1] = 
              toolkit.getImage("rabbit/rabbit" + i + ".gif");
           tracker.addImage(image[i-1], 0);
        }
        
        interval = 150;                    //δֳ(ߥ)
        timer = new Timer(interval, this); //ޡ
        timer.setInitialDelay(0);          //˻Ϥ
        timer.setCoalesce(true);           //٥ȤޤȤ
     
        setBackground(Color.white);       //ѥͥطʿ
        try{         
           tracker.waitForAll();          //ɤ򳫻
	    }catch(InterruptedException e){ return; }
        startAnimation();                 //˥᡼γ
    }

    public synchronized void startAnimation() {
       if (!timer.isRunning()) {
               timer.start();       //˥᡼γ
       }
    }

    public synchronized void stopAnimation() {
        if (timer.isRunning()) {
            timer.stop();          //˥᡼ߤ
        }
    }

    public void actionPerformed(ActionEvent e) { //󥤥٥Ƚ
        number++;  //ɽ륤᡼ֹ̤
        repaint(); //
    }

    public void paintComponent(Graphics g) {
       super.paintComponent(g); //طʤ
       int x = getWidth()/2-30; //ɥΤۤ˥᡼ɽ
       int y = getHeight()/2-30;
       try {
           g.drawImage(image[number%cell], x, y, this);
       } catch (ArrayIndexOutOfBoundsException e) { return; }
                        //number-1λ褬ƤФ줿㳰
    }

    public static void main(String[] args) {
        JFrame f = new JFrame("Timer Animation");
        TimerAnimation anime = new TimerAnimation();
        f.getContentPane().add(anime, BorderLayout.CENTER);
        f.setSize(new Dimension(100, 100));
        f.setVisible(true);
    }
}





